<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StatisticalJournalEntry StructType
 * Meta information extracted from the WSDL
 * - type: tranGeneral:StatisticalJournalEntry
 * @subpackage Structs
 */
class StatisticalJournalEntry extends Record
{
    /**
     * The createdDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $createdDate;
    /**
     * The lastModifiedDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lastModifiedDate;
    /**
     * The customForm
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RecordRef
     */
    public $customForm;
    /**
     * The tranId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $tranId;
    /**
     * The parentExpenseAlloc
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RecordRef
     */
    public $parentExpenseAlloc;
    /**
     * The approved
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $approved;
    /**
     * The tranDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $tranDate;
    /**
     * The postingPeriod
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RecordRef
     */
    public $postingPeriod;
    /**
     * The reversalDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $reversalDate;
    /**
     * The memo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $memo;
    /**
     * The reversalDefer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $reversalDefer;
    /**
     * The subsidiary
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RecordRef
     */
    public $subsidiary;
    /**
     * The unitsType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RecordRef
     */
    public $unitsType;
    /**
     * The lineList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\StatisticalJournalEntryLineList
     */
    public $lineList;
    /**
     * The customFieldList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomFieldList
     */
    public $customFieldList;
    /**
     * The internalId
     * @var string
     */
    public $internalId;
    /**
     * The externalId
     * @var string
     */
    public $externalId;
    /**
     * Constructor method for StatisticalJournalEntry
     * @uses StatisticalJournalEntry::setCreatedDate()
     * @uses StatisticalJournalEntry::setLastModifiedDate()
     * @uses StatisticalJournalEntry::setCustomForm()
     * @uses StatisticalJournalEntry::setTranId()
     * @uses StatisticalJournalEntry::setParentExpenseAlloc()
     * @uses StatisticalJournalEntry::setApproved()
     * @uses StatisticalJournalEntry::setTranDate()
     * @uses StatisticalJournalEntry::setPostingPeriod()
     * @uses StatisticalJournalEntry::setReversalDate()
     * @uses StatisticalJournalEntry::setMemo()
     * @uses StatisticalJournalEntry::setReversalDefer()
     * @uses StatisticalJournalEntry::setSubsidiary()
     * @uses StatisticalJournalEntry::setUnitsType()
     * @uses StatisticalJournalEntry::setLineList()
     * @uses StatisticalJournalEntry::setCustomFieldList()
     * @uses StatisticalJournalEntry::setInternalId()
     * @uses StatisticalJournalEntry::setExternalId()
     * @param string $createdDate
     * @param string $lastModifiedDate
     * @param \StructType\RecordRef $customForm
     * @param string $tranId
     * @param \StructType\RecordRef $parentExpenseAlloc
     * @param bool $approved
     * @param string $tranDate
     * @param \StructType\RecordRef $postingPeriod
     * @param string $reversalDate
     * @param string $memo
     * @param bool $reversalDefer
     * @param \StructType\RecordRef $subsidiary
     * @param \StructType\RecordRef $unitsType
     * @param \StructType\StatisticalJournalEntryLineList $lineList
     * @param \StructType\CustomFieldList $customFieldList
     * @param string $internalId
     * @param string $externalId
     */
    public function __construct($createdDate = null, $lastModifiedDate = null, \StructType\RecordRef $customForm = null, $tranId = null, \StructType\RecordRef $parentExpenseAlloc = null, $approved = null, $tranDate = null, \StructType\RecordRef $postingPeriod = null, $reversalDate = null, $memo = null, $reversalDefer = null, \StructType\RecordRef $subsidiary = null, \StructType\RecordRef $unitsType = null, \StructType\StatisticalJournalEntryLineList $lineList = null, \StructType\CustomFieldList $customFieldList = null, $internalId = null, $externalId = null)
    {
        $this
            ->setCreatedDate($createdDate)
            ->setLastModifiedDate($lastModifiedDate)
            ->setCustomForm($customForm)
            ->setTranId($tranId)
            ->setParentExpenseAlloc($parentExpenseAlloc)
            ->setApproved($approved)
            ->setTranDate($tranDate)
            ->setPostingPeriod($postingPeriod)
            ->setReversalDate($reversalDate)
            ->setMemo($memo)
            ->setReversalDefer($reversalDefer)
            ->setSubsidiary($subsidiary)
            ->setUnitsType($unitsType)
            ->setLineList($lineList)
            ->setCustomFieldList($customFieldList)
            ->setInternalId($internalId)
            ->setExternalId($externalId);
    }
    /**
     * Get createdDate value
     * @return string|null
     */
    public function getCreatedDate()
    {
        return $this->createdDate;
    }
    /**
     * Set createdDate value
     * @param string $createdDate
     * @return \StructType\StatisticalJournalEntry
     */
    public function setCreatedDate($createdDate = null)
    {
        // validation for constraint: string
        if (!is_null($createdDate) && !is_string($createdDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createdDate, true), gettype($createdDate)), __LINE__);
        }
        $this->createdDate = $createdDate;
        return $this;
    }
    /**
     * Get lastModifiedDate value
     * @return string|null
     */
    public function getLastModifiedDate()
    {
        return $this->lastModifiedDate;
    }
    /**
     * Set lastModifiedDate value
     * @param string $lastModifiedDate
     * @return \StructType\StatisticalJournalEntry
     */
    public function setLastModifiedDate($lastModifiedDate = null)
    {
        // validation for constraint: string
        if (!is_null($lastModifiedDate) && !is_string($lastModifiedDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastModifiedDate, true), gettype($lastModifiedDate)), __LINE__);
        }
        $this->lastModifiedDate = $lastModifiedDate;
        return $this;
    }
    /**
     * Get customForm value
     * @return \StructType\RecordRef|null
     */
    public function getCustomForm()
    {
        return $this->customForm;
    }
    /**
     * Set customForm value
     * @param \StructType\RecordRef $customForm
     * @return \StructType\StatisticalJournalEntry
     */
    public function setCustomForm(\StructType\RecordRef $customForm = null)
    {
        $this->customForm = $customForm;
        return $this;
    }
    /**
     * Get tranId value
     * @return string|null
     */
    public function getTranId()
    {
        return $this->tranId;
    }
    /**
     * Set tranId value
     * @param string $tranId
     * @return \StructType\StatisticalJournalEntry
     */
    public function setTranId($tranId = null)
    {
        // validation for constraint: string
        if (!is_null($tranId) && !is_string($tranId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tranId, true), gettype($tranId)), __LINE__);
        }
        $this->tranId = $tranId;
        return $this;
    }
    /**
     * Get parentExpenseAlloc value
     * @return \StructType\RecordRef|null
     */
    public function getParentExpenseAlloc()
    {
        return $this->parentExpenseAlloc;
    }
    /**
     * Set parentExpenseAlloc value
     * @param \StructType\RecordRef $parentExpenseAlloc
     * @return \StructType\StatisticalJournalEntry
     */
    public function setParentExpenseAlloc(\StructType\RecordRef $parentExpenseAlloc = null)
    {
        $this->parentExpenseAlloc = $parentExpenseAlloc;
        return $this;
    }
    /**
     * Get approved value
     * @return bool|null
     */
    public function getApproved()
    {
        return $this->approved;
    }
    /**
     * Set approved value
     * @param bool $approved
     * @return \StructType\StatisticalJournalEntry
     */
    public function setApproved($approved = null)
    {
        // validation for constraint: boolean
        if (!is_null($approved) && !is_bool($approved)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($approved, true), gettype($approved)), __LINE__);
        }
        $this->approved = $approved;
        return $this;
    }
    /**
     * Get tranDate value
     * @return string|null
     */
    public function getTranDate()
    {
        return $this->tranDate;
    }
    /**
     * Set tranDate value
     * @param string $tranDate
     * @return \StructType\StatisticalJournalEntry
     */
    public function setTranDate($tranDate = null)
    {
        // validation for constraint: string
        if (!is_null($tranDate) && !is_string($tranDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tranDate, true), gettype($tranDate)), __LINE__);
        }
        $this->tranDate = $tranDate;
        return $this;
    }
    /**
     * Get postingPeriod value
     * @return \StructType\RecordRef|null
     */
    public function getPostingPeriod()
    {
        return $this->postingPeriod;
    }
    /**
     * Set postingPeriod value
     * @param \StructType\RecordRef $postingPeriod
     * @return \StructType\StatisticalJournalEntry
     */
    public function setPostingPeriod(\StructType\RecordRef $postingPeriod = null)
    {
        $this->postingPeriod = $postingPeriod;
        return $this;
    }
    /**
     * Get reversalDate value
     * @return string|null
     */
    public function getReversalDate()
    {
        return $this->reversalDate;
    }
    /**
     * Set reversalDate value
     * @param string $reversalDate
     * @return \StructType\StatisticalJournalEntry
     */
    public function setReversalDate($reversalDate = null)
    {
        // validation for constraint: string
        if (!is_null($reversalDate) && !is_string($reversalDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reversalDate, true), gettype($reversalDate)), __LINE__);
        }
        $this->reversalDate = $reversalDate;
        return $this;
    }
    /**
     * Get memo value
     * @return string|null
     */
    public function getMemo()
    {
        return $this->memo;
    }
    /**
     * Set memo value
     * @param string $memo
     * @return \StructType\StatisticalJournalEntry
     */
    public function setMemo($memo = null)
    {
        // validation for constraint: string
        if (!is_null($memo) && !is_string($memo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($memo, true), gettype($memo)), __LINE__);
        }
        $this->memo = $memo;
        return $this;
    }
    /**
     * Get reversalDefer value
     * @return bool|null
     */
    public function getReversalDefer()
    {
        return $this->reversalDefer;
    }
    /**
     * Set reversalDefer value
     * @param bool $reversalDefer
     * @return \StructType\StatisticalJournalEntry
     */
    public function setReversalDefer($reversalDefer = null)
    {
        // validation for constraint: boolean
        if (!is_null($reversalDefer) && !is_bool($reversalDefer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($reversalDefer, true), gettype($reversalDefer)), __LINE__);
        }
        $this->reversalDefer = $reversalDefer;
        return $this;
    }
    /**
     * Get subsidiary value
     * @return \StructType\RecordRef|null
     */
    public function getSubsidiary()
    {
        return $this->subsidiary;
    }
    /**
     * Set subsidiary value
     * @param \StructType\RecordRef $subsidiary
     * @return \StructType\StatisticalJournalEntry
     */
    public function setSubsidiary(\StructType\RecordRef $subsidiary = null)
    {
        $this->subsidiary = $subsidiary;
        return $this;
    }
    /**
     * Get unitsType value
     * @return \StructType\RecordRef|null
     */
    public function getUnitsType()
    {
        return $this->unitsType;
    }
    /**
     * Set unitsType value
     * @param \StructType\RecordRef $unitsType
     * @return \StructType\StatisticalJournalEntry
     */
    public function setUnitsType(\StructType\RecordRef $unitsType = null)
    {
        $this->unitsType = $unitsType;
        return $this;
    }
    /**
     * Get lineList value
     * @return \StructType\StatisticalJournalEntryLineList|null
     */
    public function getLineList()
    {
        return $this->lineList;
    }
    /**
     * Set lineList value
     * @param \StructType\StatisticalJournalEntryLineList $lineList
     * @return \StructType\StatisticalJournalEntry
     */
    public function setLineList(\StructType\StatisticalJournalEntryLineList $lineList = null)
    {
        $this->lineList = $lineList;
        return $this;
    }
    /**
     * Get customFieldList value
     * @return \StructType\CustomFieldList|null
     */
    public function getCustomFieldList()
    {
        return $this->customFieldList;
    }
    /**
     * Set customFieldList value
     * @param \StructType\CustomFieldList $customFieldList
     * @return \StructType\StatisticalJournalEntry
     */
    public function setCustomFieldList(\StructType\CustomFieldList $customFieldList = null)
    {
        $this->customFieldList = $customFieldList;
        return $this;
    }
    /**
     * Get internalId value
     * @return string|null
     */
    public function getInternalId()
    {
        return $this->internalId;
    }
    /**
     * Set internalId value
     * @param string $internalId
     * @return \StructType\StatisticalJournalEntry
     */
    public function setInternalId($internalId = null)
    {
        // validation for constraint: string
        if (!is_null($internalId) && !is_string($internalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($internalId, true), gettype($internalId)), __LINE__);
        }
        $this->internalId = $internalId;
        return $this;
    }
    /**
     * Get externalId value
     * @return string|null
     */
    public function getExternalId()
    {
        return $this->externalId;
    }
    /**
     * Set externalId value
     * @param string $externalId
     * @return \StructType\StatisticalJournalEntry
     */
    public function setExternalId($externalId = null)
    {
        // validation for constraint: string
        if (!is_null($externalId) && !is_string($externalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalId, true), gettype($externalId)), __LINE__);
        }
        $this->externalId = $externalId;
        return $this;
    }
}
